
# Naslov        : Rkurs1.R  ;
# Cilj          : Uvod u R jezik;
# Keator        : Milan Kilibarda, GRF kili@grf.bg.ac.rs  ;
# last update   : Jun 2011.  ;
# inputs        : matrix.txt  , profiles.txt
# outputs       :   ...



################################################################################

# Promenljive i radno okruzenje

################################################################################

g<-9.81 # konstanta je sacuvan u promenljivoj g

g2<-g*2 # rezultat je sacuvan u promenljivoj g2

save.image("C:\\milan_r\\prvi_projekat.RData")

### Brisanje promenljivih  #####################################################

ls()  # lista svih promenljivih iz okruenja
[1] "g" "g2"

rm("g") # brisanje prom. g iz okru. 

ls() 

rm( list=ls() ) # brisanje svih prom. iz okru.

###    Ugradjene funkcije   ####################################################

? load

x<- c(1,2,3,4,8,11,18)
mean(x)

? mean

help(mean)

example(mean)

###          Pomoc za funkcije #################################################

help.search("CRS")
RSiteSearch("spTransform")

####     Neke ugradjene graficke funkcije ######################################

x <- c(12, 15, 13, 20, 14, 16, 10, 10, 8, 15)
hist(x)


x <- seq(1, 10,by=0.5)
y<- x^2- 5*x +1
plot(x,y)

###  Podesavanja konzole ######################################################

options( prompt="kili > ", continue="nastavk komande   +   ", digits=12, width=70, show.signif.stars=T)

### Lokalana podesannja

Sys.getlocale()

Sys.getlocale("LC_CTYPE")   # jezik

# localeToCharset(locale = Sys.getlocale("LC_CTYPE") )


################################################################################

# Podaci u R-u

################################################################################

### mode #######################################################################

a<-c(1,2,3)
mode(a)

b<-c("a","b","c")
mode(b)

c<-c(TRUE,FALSE,TRUE)
mode(c)

###  NA  #######################################################################

max(c(NA, 4, 7))
max(c(NA, 4, 7),na.rm=T)

NA | TRUE

NA & TRUE

### class ######################################################################

 f<-factor(c("a","b","c","a","a","b"))
 f

mode(f)

class(f)

### Vektori  ###################################################################

a<-c(1,2,3)
a*2

b<-c("a","b","c")
b

C<-c(TRUE,FALSE,TRUE)
C

a<-c(1,2,3)
length(a)  # duina vektora

summary(a)


a[2]*8     # element vektora


as.character(a)

###   Matrice ##################################################################

A<-cbind(c(11,2,3),c(8,4,2), c(88,33,11))
A

A<-rbind(c(11,8,88),c(2,4,33),c(3,2,11) )
A

x.mat <- matrix(c(3, -1, 2, 2, 0, 3, -3, 6), ncol = 2)
x.mat

x.mat[3,2]

dimnames(x.mat) <- list(c("R1","R2","R3","R4"), c("C1","C2"))
 x.mat

x.mat["R3","C2"]

###  Redovi ####################################################################

h<-1:24
Z <- array(h, dim=c(3,4,2))
Z

### Data Frames   ##############################################################

student=c("Milan","Jelena","Marko")
god_stud=c(3,3,1)
ranije_progr=c(TRUE,FALSE,TRUE)

df=data.frame(student, god_stud, ranije_progr)

df

fix(df)

str(df)

df$student

df[,1]

df[,'god_stud']

df[df$student=='Milan',]

df[df$god_stud>1,]


df[df$god_stud>1 & df$ranije_progr==T,]

###  Liste #####################################################################

kurs.l <- list(ime="R kurs", br_ucesnika=3, podaci=df)

str(kurs.l)

kurs.l$ime
kurs.l[[3]]
kurs.l[[3]]$student

### Citanje i pisanje numerickih podataka u fajl ################################
scan("matrix.txt")

matrix(scan("matrix.txt"),ncol=3,byrow=TRUE)

x <- matrix(1:10,ncol=5)
write(x, "izlaz1.txt", sep = "\t")
write(x, "izlaz1.data", sep = "\t")

### Citanje pisanje tabelarnih podataka ########################################

profili <- read.delim("profiles.txt")
str(profili)


write.csv(profili,"profili.csv")  # ,
write.csv2(profili,"profili.csv") # ;

################################################################################

# R jezik

################################################################################

########  If , ifelse   ########################################################

x<-3
if(x>2)  {
              y<-2*x } else {
                                  y<-3*x}

y<-ifelse(x>2, 2*x, 3*x)

#######   Petlje ###############################################################

for(i in 1:10) {
   print(i*i+2*i)
}

i<-1
while(i<=10) {
   print(i*i)
   i<-i+sqrt(i)
}
###  Funkcije ##################################################################

gs <- function(a,b) {
	result <- sqrt(a*b)
  	return(result)
}

gs(7,88)

###  aplly ####################################################################

A<-cbind(c(11,2,3) , c(8,4,2) , c(88,33,11) )

apply(A, 1, sum) # suma po vrstama

apply(A, 2, sum) # suma po kolonama

apply(A, 2, sort) # sortiranje po kolonama

apply(A,1, function(x) x/max(x) )

apply(A,2, function(x) x/max(x) )

#### lapply  sapply ############################################################

numList<-list(x=1:10,y=rnorm(100, 5, 5), z=rpois(100, 45))
lapply(numList, mean)
sapply(numList, mean)



txt<-c("GRF","stat","Rcourse")
lapply(txt, nchar)
sapply(txt, nchar)

###   Napredan primer moze biti kasnije koristan

fajlovi_wd<- list.files()  # dir()
fajlovi_wd

a<- regexpr(".txt",fajlovi_wd[[1]],fixed=T)
a


 attr(a,"match.length")

vec<-sapply(fajlovi_wd, function(x) attr(regexpr(".txt",x,fixed=T),  "match.length") ==4)

fajlovi_wd[vec]

################################################################################

# R grafici

################################################################################


data()
data(cars)
help(cars)
str(cars)

plot(cars$dist~cars$speed)

plot(cars$dist~cars$speed,   # y~x
main='Odnos zaustavnog puta i brzine', # Naslov
xlab='Brzina (mph)', # X osa naslov
ylab='Zaustavni put (milje)', # Y osa naslov
xlim=c(0,30), # X osa u granicama 0-30
ylim=c(0,140), # Y osa u granicama 0-30
xaxs='i', # internal stil X ose
yaxs='i', # internal stil Y ose
col='red', # Boja ploting simbola
pch=19) # Velicina simbola u tackama

### barplot ####################################################################

data(airquality)
str(airquality)
heights <- tapply(airquality$Temp, airquality$Month, mean)
barplot(heights)

 barplot(heights,
          main="Mean Temp. by Month",
           names.arg=c("May", "Jun", "Jul", "Aug", "Sep"),
           ylab="Temp (deg. F) ",
           legend=c("May", "Jun", "Jul", "Aug", "Sep"),
           col=heat.colors(5),
           border="white")

#### histogram #################################################################

data(Cars93, package="MASS")
str(Cars93)

hist(Cars93$MPG.city)

hist(Cars93$MPG.city,20)

##

dest <- density(Cars93$MPG.city)
hist(Cars93$MPG.city,20,probability = TRUE)
lines(dest, lty=2)

####    boxplot ################################################################

data(ToothGrowth)
str(ToothGrowth)


boxplot(len ~ dose,
         data = ToothGrowth,
         boxwex = 0.25,
         at = 1:3 - 0.2,
         subset = supp == "VC",
         col = "yellow",
         main = "Guinea Pigs' Tooth Growth",
         xlab = "Vitamin C dose mg",
         ylab = "tooth length",
         xlim = c(0.5, 3.5),
         ylim = c(0, 35),
         yaxs = "i")
         
################################################################################

# Linearna regresija

################################################################################

set.seed(520)

len <- 24
x <- runif(len)   # simuliranje x vrednosti

Y<- 2*x + rnorm(len, 0, 0.06) # simuliranje slucajne promenljive   Y= 2*x+ greske

ds <- data.frame(x = x, Y= Y)
str(ds)

# graficki prikaz ulaznih podataka
plot(Y ~ x, main = "Prava sa sluc. gres")
s <- seq(0, 1, length = 100)
lines(s, 2*s, lty = 2, col = "green")

###  lm  linearni model (regresini model) ######################################

m<- lm(Y~ x)
m

#anova(m) 	         # ANOVA tabela
coefficients(m)    # ; coef(m) 	Koeficijenti modela
confint(m) 	       # Intervali poverenja za koef.
deviance(m) 	     # Suma kvadrata reziduala
# effects(m)         # Vektor ortogonalnog efekta
fitted(m) 	       # Vektor predikovane Y vrednosti
residuals(m)       # ; resid(m) 	Reziduali
summary(m)	       # R2; F statistika; standardna greka reziduala (?) ...
vcov(m) 	         # Varijans-kovarijans matrica parametara

### plotovanje rezultata regresije

par(mfrow = c(2, 2))     # delimo plot podrucje u 2 vrste i 2 kolone
plot(m)

par(mfrow = c(1, 1))      # vracemo plot podesavanja na staro






#################################################################################
###  Svaki pocetak je tezak :)





